      SUBROUTINE  RCASPLT1
C 
C        RCASPLT1 SETS UP THE -DIAG- AND -AVECT- VECTORS
C                 FOR THE SPLIT AND FULL TIMESTEP SEGMENTS
C                 IF SMOLARKIEWICZ CORRECTION THEN -DIAG- AND -AVECT-
C                 CONTAIN JUST ADVECTIVE TERMS
C                 IF NO SMOLARKIEWICZ CORRECTION THEN -DIAG- AND -AVECT-
C                 CONTAIN ADVECTIVE AND HORIZONTAL DISPERSIVE TERMS
C 
      SAVE
      INCLUDE  'RCACM'

      REAL   TIMESTEP(NX,NY,NZ)
      EQUIVALENCE  (TIMESTEP(1,1,1),SCRATCH_TRAN(1,1,1,1))

      DO 100 IT=1,6
      DO 100 IZ=0,NZ+1
      DO 100 IY=1,NY
      DO 100 IX=1,NX
        AVECT(IX,IY,IZ,IT) = 0.
 100  CONTINUE

      DO 110 IZ=1,NZ
      DO 110 IY=1,NY
      DO 110 IX=1,NX
        DIAG(IX,IY,IZ) = 0.
 110  CONTINUE

      DO 120 IZ=1,NZ
      DO 120 IY=1,NY
      DO 120 IX=1,NX
        FSMSPLT(IX,IY,IZ) = 0
 120  CONTINUE

C        CHECK FOR SMOLARKIEWICZ OPTION
C          IF NOT THEN INCLUDE HORIZONTAL MIXING
C          IN -DIAG- AND -AVECT- VECTORS
      IF(INTGRTYP.EQ.3)  THEN
       IF(NZ.GT.1) THEN
        DO 150 IZ=1,NZ
          DO 150 IY=2,NY-1
            IS = IXS(IY)
            IE = IXE(IY)
            IF(IS.EQ.0)   GO TO 150
            DO 149 IX=IS,IE
              IF (FSM(IX,IY).LE.0.0)  GO TO 149
              IF (FSM(IX-1,IY).NE.0.0) AVECT(IX,IY,IZ,1)=RX(IX,IY,IZ)
              IF (FSM(IX+1,IY).NE.0.0) AVECT(IX,IY,IZ,2)=RX(IX+1,IY,IZ)
              IF (FSM(IX,IY-1).NE.0.0) AVECT(IX,IY,IZ,3)=RY(IX,IY,IZ)
              IF (FSM(IX,IY+1).NE.0.0) AVECT(IX,IY,IZ,4)=RY(IX,IY+1,IZ)
              DIAG(IX,IY,IZ)=0.0
              IF (FSM(IX-1,IY).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                                RX(IX,IY,IZ)
              IF (FSM(IX+1,IY).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                                RX(IX+1,IY,IZ)
              IF (FSM(IX,IY-1).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                                RY(IX,IY,IZ)
              IF (FSM(IX,IY+1).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                                RY(IX,IY+1,IZ)
 149      CONTINUE
 150    CONTINUE

      ELSE

        IZ=1
        DO 160 IY=2,NY-1
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0)   GO TO 160
          DO 159 IX=IS,IE
            IF (FSM(IX,IY).LE.0.0)  GO TO 159
            IF (FSM(IX-1,IY).NE.0.0) AVECT(IX,IY,IZ,1)=RX(IX,IY,IZ)
            IF (FSM(IX+1,IY).NE.0.0) AVECT(IX,IY,IZ,2)=RX(IX+1,IY,IZ)
            IF (FSM(IX,IY-1).NE.0.0) AVECT(IX,IY,IZ,3)=RY(IX,IY,IZ)
            IF (FSM(IX,IY+1).NE.0.0) AVECT(IX,IY,IZ,4)=RY(IX,IY+1,IZ)
C
            DIAG(IX,IY,IZ)=0.0
            IF (FSM(IX-1,IY).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                              RX(IX,IY,IZ)
            IF (FSM(IX+1,IY).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                              RX(IX+1,IY,IZ)
            IF (FSM(IX,IY-1).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                              RY(IX,IY,IZ)
            IF (FSM(IX,IY+1).NE.0.0) DIAG(IX,IY,IZ)=DIAG(IX,IY,IZ)+
     +                                              RY(IX,IY+1,IZ)
 159      CONTINUE
 160    CONTINUE
       ENDIF
      ENDIF
C
      DO 200 IZ=1,NZ
        DO 200 IY=2,NY-1
          IS = IXS(IY)
          IE = IXE(IY)
          IF(IS.EQ.0)   GO TO 200
          DO 199 IX=IS,IE

      IF (FSM(IX,IY).LE.0.0)  GO TO 199

      IF(QX(IX,IY,IZ).GT.0.)  THEN
         AVECT(IX,IY,IZ,1) = AVECT(IX,IY,IZ,1) + QX(IX,IY,IZ)
      ELSE
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) - QX(IX,IY,IZ)
      ENDIF

      IF(QX(IX+1,IY,IZ).GT.0.)  THEN
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) + QX(IX+1,IY,IZ)
      ELSE
         AVECT(IX,IY,IZ,2) = AVECT(IX,IY,IZ,2) - QX(IX+1,IY,IZ)
      ENDIF

      IF(QY(IX,IY,IZ).GT.0.)  THEN
         AVECT(IX,IY,IZ,3) = AVECT(IX,IY,IZ,3) + QY(IX,IY,IZ)
      ELSE
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) - QY(IX,IY,IZ)
      ENDIF

      IF(QY(IX,IY+1,IZ).GT.0.)  THEN
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) + QY(IX,IY+1,IZ)
      ELSE
         AVECT(IX,IY,IZ,4) = AVECT(IX,IY,IZ,4) - QY(IX,IY+1,IZ)
      ENDIF

      IF (NZ.EQ.1)  GO TO 199

      IF(QZ(IX,IY,IZ).GT.0.)  THEN
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) + QZ(IX,IY,IZ)
      ELSE
         AVECT(IX,IY,IZ,5) = AVECT(IX,IY,IZ,5) - QZ(IX,IY,IZ)
      ENDIF

      IF(QZ(IX,IY,IZ+1).GT.0.)  THEN
         AVECT(IX,IY,IZ,6) = AVECT(IX,IY,IZ,6) + QZ(IX,IY,IZ+1)
      ELSE
         DIAG(IX,IY,IZ) = DIAG(IX,IY,IZ) - QZ(IX,IY,IZ+1)
      ENDIF

  199 CONTINUE
  200 CONTINUE


C
C         ZERO TRANSPORT TERMS FOR BOUNDARY SEGMENTS
C
      DO 210 I=1,NOBCALL
        IX = IBCALL(1,I)
        IY = IBCALL(2,I)
        IZ = IBCALL(3,I)
        DIAG(IX,IY,IZ) = 0.0
        DO 220 IT=1,6
          AVECT(IX,IY,IZ,IT) = 0.0
  220   CONTINUE
  210 CONTINUE

      NSEGSPLT = 0
C        IF PERFORMING SPLIT TIMESTEPS (DTSPLIT.NE.DTFULL)
      IF(DTSPLIT.EQ.DTFULL)  RETURN
C        GENERATE VECTOR OF SEGMENTS WITH TIMESTEP
C        REQUIREMENTS BELOW -DTFULL-
      DO 240 IZ=1,NZ
       DO 240 IY=1,NY
        IS = IXS(IY)
        IE = IXE(IY)
        IF(IS.EQ.0)   GO TO 240
        DO 239 IX=IS,IE
         IF(FSM(IX,IY).LE.0.0)  GO TO 239
         IF(0.9*TIMESTEP(IX,IY,IZ).LE.DTFULL)  THEN
           NSEGSPLT = NSEGSPLT+1
           IF(NSEGSPLT.GT.MXSEGSPLT)  GO TO 300
           ISEGSPLT(NSEGSPLT,1) = IX
           ISEGSPLT(NSEGSPLT,2) = IY
           ISEGSPLT(NSEGSPLT,3) = IZ
           FSMSPLT(IX,IY,IZ) = 1
           VDERSPLT(NSEGSPLT) = VDER(IX,IY,IZ)
           VDER(IX,IY,IZ) = 0.0
           DIAGSPLT(NSEGSPLT) = DIAG(IX,IY,IZ)
           DIAG(IX,IY,IZ) = 0.0
           DO 230 IT=1,6
            AVECTSPLT(NSEGSPLT,IT) = AVECT(IX,IY,IZ,IT)
  230      CONTINUE
           AVECTSPLT(NSEGSPLT,7) = AVECT(IX-1,IY,IZ,2)
           AVECTSPLT(NSEGSPLT,8) = AVECT(IX+1,IY,IZ,1)
           AVECTSPLT(NSEGSPLT,9) = AVECT(IX,IY-1,IZ,4)
           AVECTSPLT(NSEGSPLT,10) = AVECT(IX,IY+1,IZ,3)
           IF(IZ.EQ.1)  THEN
             AVECTSPLT(NSEGSPLT,11) = 0.0
           ELSE
             AVECTSPLT(NSEGSPLT,11) = AVECT(IX,IY,IZ-1,6)
           ENDIF
           IF(IZ.EQ.NZ)  THEN
             AVECTSPLT(NSEGSPLT,12) = 0.0
           ELSE
             AVECTSPLT(NSEGSPLT,12) = AVECT(IX,IY,IZ+1,5)
           ENDIF
         ENDIF
  239  CONTINUE
  240 CONTINUE

      DO 270 ISEG=1,NSEGSPLT
       IX =  ISEGSPLT(ISEG,1)
       IY =  ISEGSPLT(ISEG,2)
       IZ =  ISEGSPLT(ISEG,3)
       DO 260 IT=1,6
         AVECT(IX,IY,IZ,IT) = 0.0
  260  CONTINUE
       AVECT(IX-1,IY,IZ,2) = 0.0
       AVECT(IX+1,IY,IZ,1) = 0.0
       AVECT(IX,IY-1,IZ,4) = 0.0
       AVECT(IX,IY+1,IZ,3) = 0.0
       IF(IZ.NE.1)  THEN
         AVECT(IX,IY,IZ-1,6) = 0.0
       ENDIF
       IF(IZ.NE.NZ)  THEN
         AVECT(IX,IY,IZ+1,5) = 0.0
       ENDIF
  270 CONTINUE

      RETURN

  300 WRITE(OUT,3000)   DTFULL,MXSEGSPLT
 3000 FORMAT(///15X,'ERROR...NUMBER OF SEGMENTS BELOW -DTFULL- (',F10.4,
     .   ') EXCEEDED -MXSEGSPLT- OF',I6/15X,'RCA TERMINATED')
      CALL EXIT
      END
